/// <reference types="node" />
import { URL } from 'url';
interface APIClientConfig {
    auth: string;
    apiUrl: URL;
}
export interface HerokuAPIErrorOptions {
    resource?: string;
    app?: {
        id: string;
        name: string;
    };
    id?: string;
    message?: string;
    url?: string;
}
type ResponseType<T> = {
    data: T;
    [key: string]: any;
};
export default class APIClient {
    private auth;
    private apiUrl;
    constructor(options: APIClientConfig);
    request<T>(url: string, options: any): Promise<ResponseType<T>>;
    get<T>(url: string, options?: Record<string, unknown>): Promise<ResponseType<T>>;
    post<T>(url: string, options?: Record<string, unknown>): Promise<ResponseType<T>>;
    put<T>(url: string, options?: Record<string, unknown>): Promise<ResponseType<T>>;
    patch<T>(url: string, options?: Record<string, unknown>): Promise<ResponseType<T>>;
    delete<T>(url: string, options?: Record<string, unknown>): Promise<ResponseType<T>>;
}
export declare function herokuClientApiUrl(): URL;
export {};
